#! /usr/local/bin/perl

use warnings;
use strict;

sub usage {
    "Usage: $0 n\n" .
    "  where n is a decimal integer\n"
}

# memoizing doesn't seem to help
#memoize 'parens';

sub parens {
    my $n = shift;

    return ""   if $n <= 0;
    return "()" if $n == 1;

    my %uniq;
    @uniq{ "()$_", "($_)", "$_()" } = () for parens($n-1);

    if ($n & 1) {
        @uniq{ "()$_$_", "$_()$_", "$_$_()" } = () for parens(int($n/2));
    }
    else {
        $uniq{"$_$_"} = () for parens($n/2);
    }

    keys %uniq;
}

$0 =~ s,^.*[/\\],,;

my $n = @ARGV ? shift : "";

die usage unless $n =~ /^-?\d+$/;

print $_, "\n" for sort +parens $n;

