#! /usr/local/bin/perl

use warnings;
use strict;

sub usage {
    "Usage: $0 n\n" .
    "  where n is a decimal integer\n"
}

sub walk {
    my @forest = @{ shift @_ };

    return ""   if @forest == 0;
    return "()" if @forest == 1 and not @{ $forest[0] };

    join "", map "(" . walk($_) . ")", @forest;
}

sub move_left {
    my @f    = @{ shift @_ };
    my $uniq = shift;

    ++$uniq->{ walk \@f };

    foreach my $i (1 .. $#f) {
        my @new = @f;

        $new[$i-1] = [ @{ $f[$i-1] }, $f[$i] ];
        splice @new, $i, 1;
        ++$uniq->{ walk \@new };

        move_left(\@new, $uniq);
    }

}

sub parens {
    my $n = shift;

    return ""   if $n <= 0;
    return "()" if $n == 1;

    move_left [ map [], 1..$n ], \my %uniq;

    keys %uniq;
}

$0 =~ s,^.*[/\\],,;

my $n = @ARGV ? shift : "";

die usage unless $n =~ /^-?\d+$/;

print $_, "\n" for sort +parens $n;

