#! /usr/local/bin/perl

use warnings;
use strict;

sub usage {
    "Usage: $0 n\n" .
    "  where n is a decimal integer\n"
}

sub parens {
    my $n = shift;

    return if $n <= 0;

    if ($n == 1) {
        print "()\n";
        return;
    }

    my %uniq;  # valid strings

    my @agenda = [ map [], 1..$n ];

    my $STOP = 42;

    while (@agenda) {
        my $f = shift @agenda;

        my $trav;
        my @walk = @$f;
        while (@walk) {
            my $item = shift @walk;

            if ($item == $STOP) {
                $trav .= ")";
            }
            else {
                $trav .= "(";

                unshift @walk => @$item, $STOP;
            }
        }

        next if $uniq{$trav}++;
        print $trav, "\n";

        foreach my $i (1 .. $#$f) {
            my @new = @$f;

            $new[$i-1] = [ @{ $new[$i-1] }, $new[$i] ];
            splice @new, $i, 1;

            unshift @agenda => \@new;
        }
    }

    return;
}

$0 =~ s,^.*[/\\],,;

my $n = @ARGV ? shift : "";

die usage unless $n =~ /^-?\d+$/;

parens $n;

