#! /usr/local/bin/perl

use warnings;
use strict;

sub usage {
    "Usage: $0 n\n" .
    "  where n is a decimal integer\n"
}

sub parens {
    my $n = shift;

    return if $n <= 0;

    if ($n == 1) {
        print "()\n";
        return;
    }

    my %uniq;  # valid strings

    my @agenda = join " " => map "()", 1..$n;

    (my $copy = $agenda[0]) =~ tr/ //d;
    print $copy, "\n";

    my($f,$orig);

    while (@agenda) {
        $f = pop @agenda;

        $orig = $f;
        while ($f =~ s/\G(\(\S*\)) +\((\S*)\)(?: +|$)/($1 $2) /) {
            ($copy = $f) =~ tr/ //d;
            unless ($uniq{$copy}++) {
                print $copy, "\n";
                push @agenda, $f;
            }

            $f = $orig;
            pos($f) = $-[2] - 1;
        }
    }

    return;
}

$0 =~ s,^.*[/\\],,;

my $n = @ARGV ? shift : "";

die usage unless $n =~ /^-?\d+$/;

parens $n;

