#!/usr/bin/perl -w

# Print permutations of pretty pairs of parenthesis.

use strict;
use Term::ANSIColor ':constants';

my $PAIRS = $ARGV[0];
die "we need a number of pairs to print\n" 
    unless $PAIRS && $PAIRS =~ /[[:digit:]]/;

my @colors = (RED, YELLOW, GREEN, BLUE, MAGENTA);
my $num_colors = scalar @colors;
my $col_index = 0;

build([1]);

sub build{
    my $string = shift;

    if (my $branches = get_branches($string)){
	for (@$branches){
	    build([@$string, $_]);
	}
    }else{
	print_string($string);
	print RESET;
    }
}

sub get_branches{
    my $string = shift;

    my $possible_branches;
    my ($o, $c) = (0, 0);
    for (@$string){ $_ ? $o++ : $c++ }
    if ($o < $PAIRS){ push @$possible_branches, 1 }
    if ($c < $o){ push @$possible_branches, 0 }
    return $possible_branches;
}

sub print_string{
    my $string = shift;

    my $index = 0;
    my @acum;
    for (@$string){
	if ($_){
	    my $i = $index % $num_colors;
	    print $colors[$i] . '(';
	    $index++;
	    push @acum, $i;
	}else{
	    print $colors[pop(@acum)] . ')';
	}
    }
    print "\n";
}

