#!/usr/bin/python

## qotw23.py
# Python solution to the Perl quiz of the week #23
# See http://perl.plover.com/qotw/r/023

def gen(remaining, open_count):
     # If so, I can only have close parens
     if remaining == open_count:
         yield ")" * open_count
     else:
         # I can always have an '('
         for s in gen(remaining-1, open_count+1):
             yield "(" + s
         # Can I have a ')'?
         if open_count > 0:
             for s in gen(remaining-1, open_count-1):
                 yield ")" + s

def qotw23(n):
     if n < 0: raise TypeError, "must use a positive number"
     if n == 0: return []
     return gen(n*2, 0)

### Everything below here is test and driver code

def test():
     if list(qotw23(0)) != [""]:
         raise AssertionError("wrong for 0")
     if list(qotw23(1)) != ["()"]:
         raise AssertionError("wrong for 1")

     expected = """
         (((())))
         ((()()))
         ((())())
         ((()))()
         (()(()))
         (()()())
         (()())()
         (())(())
         (())()()
         ()((()))
         ()(()())
         ()(())()
         ()()(())
         ()()()()
         """.split()
     expected = [s.strip() for s in expected if s.strip()]
     expected.sort()
     got = list(qotw23(4))
     got.sort()
     if expected != got:
         raise AssertionError("different!")


def main(argv):
     args = argv[1:]
     only_count = 0
     if args and args[0] == "--count":
         only_count = 1
         del args[0]

     if not args:
         raise AssertionError("need a count")
     n = int(args[0])

     if only_count:
         count = 0
         for s in qotw23(n):
             count = count + 1
         print count
     else:
         for s in qotw23(n):
             print s

if __name__ == "__main__":
     import sys
     if len(sys.argv) == 1:
         test()
         print "All tests passed."
     else:
         main(sys.argv)


