#!/usr/bin/perl -w

use strict;

my $length = 2 * (shift || 0);

die "Usage: parens <n>\n" unless $length > 0;

my @pipeline = ("");

my %seen;

while(@pipeline) {
    my $item = shift @pipeline;

    for(my $i = 0; $i <= length $item; $i++) {
        my $newitem = $item;
        substr($newitem, $i, 0) = "()";
        next if $seen{$newitem}++;
        if (length $newitem == $length) {
            print "$newitem\n";
        } else {
            push @pipeline, $newitem;
        }
    }
}
