#!/usr/bin/perl
use strict;
use warnings;
use Algorithm::Loops qw( NestedLoops );

my $n = shift;
die "Usage: $0 n [where n is a positive integer]" unless defined $n
and $n !~ /\D/;
exit unless $n;
print "()\n" and exit if $n == 1;

sub create_iterator_closure {
   my $p = $_[0]*2-1;
   return sub { [ $_+1..$p ] };
}

my (@parens, @right, @left);
@right = (')') x (2*$n-2);
@left = ('(') x (2*$n-2);

my $loop = [[0..1]];
push(@$loop, create_iterator_closure($_)) for (2..$n-1);
my $iter = NestedLoops($loop);
while (my @list = $iter->()) {
    @parens = @right;
    @parens[@list] = @left;
    print join '', '(', @parens, ')', "\n";
}

