#!/usr/bin/perl -w

use strict;

my $length = 2 * (shift || 0);

die "Usage: parens <n>\n" unless $length > 0;

my @pipeline = ("()");

while(@pipeline) {
    my $item = shift @pipeline;

    my $limit = index $item, ')';
    for(my $i = 0; $i <= $limit; $i++) {
        my $newitem = $item;
        substr($newitem, $i, 0) = "()";
        if (length $newitem == $length) {
            print "$newitem\n";
        } else {
            push @pipeline, $newitem;
        }
    }
}

__END__

This has the disadvantage of not nicely handling the case when n=0,
but Bruce's program was already die'ing in that case anyway.  I
figured out this by running Bruce's program and then using
Data::Dumper to print out %seen.  Here's what I got - the pattern
should be obvious:

$VAR1 = {
          '(())()()' => 3,
          '()()' => 2,
          '(())' => 1,
          '(()())()' => 3,
          '(())()' => 2,
          '(()()())' => 3,
          '(((())))' => 1,
          '()(()())' => 3,
          '(()())' => 2,
          '()(())()' => 3,
          '(()(()))' => 2,
          '((()))()' => 2,
          '()(())' => 2,
          '()((()))' => 2,
          '()()()' => 3,
          '()()()()' => 4,
          '()' => 1,
          '((())())' => 2,
          '()()(())' => 3,
          '((()()))' => 2,
          '(())(())' => 2,
          '((()))' => 1
        };

