#!/usr/bin/perl

use strict;
use warnings;

my $n = shift;
defined $n and $n > 0 or die <<USAGE;
Usage: $0 positive_integer
USAGE

for my $b (@{balanced($n)}) {
     my @in_chars = map { $_ > 0 ? '(' : ')' } @$b;
     print join '', @in_chars, "\n";
}

sub balanced {
     my $n = shift;
     return [[1, -1]] if $n == 1;
     my @bs = ();
     for $b (@{balanced($n - 1)}) {
         push @bs, [1, -1, @$b];
         my $count = 0;
         my $offset = 0;
         for my $p (@$b) {
             ++$offset;
             $count += $p;
             if ($count <= 0) {
                 my @new = @$b;
                 splice @new, $offset, 0, -1;
                 push @bs, [1, @new];
             }
         }
     }
     return \@bs;
}

