#!/usr/bin/perl

use strict;
use warnings;
use List::Util 'sum';

# slow, but doesn't use any memory to speak of; works for up to 19 pairs
# with 32-bit ints or 35 pairs with 64-bit ints

my $count = shift;
die "Usage: parens PAIRS\n",
    "Prints all strings of PAIRS balanced pairs of parentheses\n"
    if @ARGV or !defined($count) or $count !~ /^\d+\z/;

my @catalan = 1;
push @catalan, sum map $catalan[$_] * $catalan[$#catalan-$_], 0..$#catalan
    while @catalan <= $count;

sub string {
    my ($count, $index) = @_;
    return "" unless $count;

    my $in = 0;
    my $product;
    ++$in, $index -= $product
        while $index >= ($product = $catalan[$count-$in-1] * $catalan[$in]);

    "(".string($in, int($index % $catalan[$in])).")".
        string($count-1-$in, int($index / $catalan[$in]));
}

$\ = "\n";
if ($count) {
    print string($count, $_) for 0..$catalan[$count]-1;
}

