#!/usr/bin/perl -w
use strict;

# Iterative version

# To produce all strings of $n paren pairs, decide how many paren
# pairs go into the first paren pair and how many go outside it, and
# do the cartesian multiple.

my $n = shift;

my @parens = (['']);

for my $m (1..$n) {
  # Generate $parens[$m]
  for my $i (0..$m-1) {
    # Generate '(' x $parens[$m-1-$i] x ')' x $parens[$i]
    for my $in (@{$parens[$m-$i-1]}) {
      for my $out (@{$parens[$i]}) {
	push @{$parens[$m]}, "($in)$out";
      }
    }
  }
}

print "$_\n" for (@{$parens[$n]});

