#!/usr/bin/perl -w
#
#  First solution - this uses lots of memory for large n

use strict;

my $n;                      # 2n is the length of the strings to produce
my ($strings, $newStrings); # Refs to arrays containing the output strings
my ($sums,    $newSums   ); # For each string, # of "("s - # of ")"s

$n = shift;                 # Get $n from the command line
($n =~ /^\d+$/) or die "Please specify a numeric length!\n";

$strings = [""];
$sums    = [0];

foreach (0..2*$n-1)
     {
     # Init the new strings and sums arrays
     $newStrings = [];
     $newSums    = [];

     foreach (0..scalar(@$strings)-1)
         {
         # Check to see if we can add a ( to the string
         if ($$sums[$_] + length($$strings[$_]) < 2*$n)
             {
             push (@$newStrings, $$strings[$_]."(");
             push (@$newSums,    $$sums[$_]+1);
             }
         # Check to see if we can add a ) to the string
         if ($$sums[$_] > 0)
             {
             push (@$newStrings, $$strings[$_].")");
             push (@$newSums,    $$sums[$_]-1);
             }
         }
     $strings = $newStrings;
     $sums    = $newSums;
     }
foreach (@$strings)
     {
     print "$_\n";
     }
exit;

