#!/usr/bin/perl -w
#
# Second solution - uses very little memory

use strict;

my $n;                        # 2n is the length of the strings to produce
my (@triedLeft, @triedRight); # For each 'node', have we tried to add ( and )?
my (@curString);              # An array of the chars in the string
my ($sum);                    # For current string, # of '(' - # of ')'
my ($curPos);                 # Where in the string are we?

$n = shift;                   # Get $n from the command line
defined($n) and ($n =~ /^\d+$/) or die "Please specify a numeric length!\n";
$n or exit;

foreach (0..2*$n-1)
     {
     $triedLeft[$_]  = 0;
     $triedRight[$_] = 0;
     }

$curPos = 0;
$sum    = 0;

while (1)
     {
     # Check to see if we can add a ( to the string
     if (!$triedLeft[$curPos] and ($sum + $curPos) < 2*$n)
         {
         push (@curString,"(");
         $triedLeft[$curPos] = 1;
         $curPos++;
         $sum++;
         }
     # Check to see if we can add a ) to the string
     elsif (!$triedRight[$curPos] and $sum > 0)
         {
         push (@curString,")");
         $triedRight[$curPos] = 1;
         $curPos++;
         $sum--;
         }
     else # This node is done; reset it and pop up to its parent
         {
         $triedLeft[$curPos]  = 0;
         $triedRight[$curPos] = 0;
         $curPos--;
         (pop(@curString) eq "(") ? ($sum--) : ($sum++);
         }
     $curPos or last; # Once we've popped back to the top, we're done
     ($curPos > 2*$n-1) and print join('',@curString)."\n";
     }
exit;

